#include <iostream>
#include <vector>

using namespace std;

int main()
{
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
    size_t number_count, bin_count;
    cerr << "Enter number count: ";
    cin >> number_count;
    vector<double> numbers(number_count);
    for (size_t i = 0; i < number_count; i++)
    {
        cin >> numbers[i];
    }
    cerr << "Enter bin count: ";
    cin >> bin_count;
    vector<size_t> bins(bin_count);
    double min = numbers[0];
    double max = numbers[0];
    for (double x : numbers)
    {
        if (x < min)
        {
            min = x;
        }
        else if (x > max)
        {
            max = x;
        }
    }
    auto bin_size = (max - min)/bin_count;
    for (size_t i = 0; i < number_count; i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }
        }
        if (!found)
        {
            bins[bin_count - 1]++;
        }
    }
    size_t max_count = 0;
    for (size_t s = 0; s < bin_count; s++) {
        if (bins[s] > max_count)
            {
                max_count = bins[s];
            }
    }
    for (size_t bin : bins)
    {
        if (bin <100)
        {
            cout << " ";
        }
        if (bin <10)
        {
            cout << " ";
        }
        cout << bin << "|";
        if (max_count > MAX_ASTERISK) {
            size_t count = bin;
            size_t height = MAX_ASTERISK * (static_cast<double>(count) / max_count);
            for (size_t t = 0; t < height; t++)
            {
                cout << "*";
            }
        }
        else for (size_t k = 0; k < bin; k++)
            {
                cout << "*";
            }
        cout << endl;
    }
}
